#!/usr/bin/env python

# Copyright (C) 2002 Jrg Lehmann <joerg@luga.de>
#
# This file is part of PyTone (http://www.luga.de/pytone/)
#
# PyTone is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
#
# PyTone is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with PyX; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import mad
import pcm

class mp3file:
    def __init__(self, path, outrate, title, ttime):
        self.path = path
        self.outrate = outrate
        self.title = title
        self.ttime = ttime
        
        self.madfile = mad.MadFile(path)
        self.samplerate = self.madfile.samplerate()
        
        newbuff = self.madfile.read()
        if newbuff:
            self.buff, self.last_l, self.last_r = \
                       pcm.rate_convert(newbuff,
                                        self.samplerate,
                                        None,
                                        None,
                                        self.outrate,
                                        None,
                                        None)
        else:
            self.buff = []
            self.last_l = None
            self.last_r = None
        self.buffpos = 0
        self.ptime = 0
        
    def read(self, size):
        
        bytesleft = len(self.buff) - self.buffpos

        # fill buffer, if necessary 
        while bytesleft<size:
            newbuff = self.madfile.read()
            if newbuff:
                self.buff, self.last_l, self.last_r = \
                           pcm.rate_convert(newbuff,
                                            self.samplerate,
                                            self.buff,
                                            self.buffpos,
                                            self.outrate,
                                            self.last_l,
                                            self.last_r)

                # the new self.buff contains only new data
                self.buffpos = 0
                bytesleft = len(self.buff)
            else:
                size = bytesleft
                break

        oldpos = self.buffpos
        self.buffpos += size
        self.ptime += 1000.0/4*size/self.samplerate
        
        return self.buff[oldpos:self.buffpos]
